searchNodes=[{"ref":"Exnowflake.html","title":"Exnowflake","type":"module","doc":"Exnowflake is an Elixir application used to generate decentralized, unique, time based IDs."},{"ref":"Exnowflake.html#generate/0","title":"Exnowflake.generate/0","type":"function","doc":"See Exnowflake.Worker.generate/0."},{"ref":"Exnowflake.html#internal_timestamp/1","title":"Exnowflake.internal_timestamp/1","type":"function","doc":"See Exnowflake.Worker.internal_timestamp/1."},{"ref":"Exnowflake.html#timestamp/1","title":"Exnowflake.timestamp/1","type":"function","doc":"See Exnowflake.Worker.timestamp/1."},{"ref":"Exnowflake.html#worker_id/0","title":"Exnowflake.worker_id/0","type":"function","doc":"See Exnowflake.Registry.worker_id/0."},{"ref":"Exnowflake.Registry.html","title":"Exnowflake.Registry","type":"module","doc":"A Redis backed GenServer that exposes API for getting cluster machines registry."},{"ref":"Exnowflake.Registry.html#child_spec/1","title":"Exnowflake.Registry.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Exnowflake.Registry.html#local_registry/0","title":"Exnowflake.Registry.local_registry/0","type":"function","doc":"Returns all locally registered workers sorted by time."},{"ref":"Exnowflake.Registry.html#redis_registry/0","title":"Exnowflake.Registry.redis_registry/0","type":"function","doc":"Returns all Redis registered workers sorted by time."},{"ref":"Exnowflake.Registry.html#start_link/1","title":"Exnowflake.Registry.start_link/1","type":"function","doc":""},{"ref":"Exnowflake.Registry.html#worker_id/0","title":"Exnowflake.Registry.worker_id/0","type":"function","doc":"Returns the current node worker number."},{"ref":"Exnowflake.Worker.html","title":"Exnowflake.Worker","type":"module","doc":"This worker generates unique time based IDs."},{"ref":"Exnowflake.Worker.html#child_spec/1","title":"Exnowflake.Worker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Exnowflake.Worker.html#generate/0","title":"Exnowflake.Worker.generate/0","type":"function","doc":"Generates a 64 bit integer based on time, worker ID and a sequence."},{"ref":"Exnowflake.Worker.html#internal_timestamp/1","title":"Exnowflake.Worker.internal_timestamp/1","type":"function","doc":"Returns milliseconds passed since epoch when ID was generated."},{"ref":"Exnowflake.Worker.html#start_link/1","title":"Exnowflake.Worker.start_link/1","type":"function","doc":""},{"ref":"Exnowflake.Worker.html#timestamp/1","title":"Exnowflake.Worker.timestamp/1","type":"function","doc":"Returns the real timestamp of an ID in milliseconds."},{"ref":"readme.html","title":"Exnowflake","type":"extras","doc":"Exnowflake Exnowflake is an Elixir application used to generate decentralized, unique, time based IDs. It&#39;s inspired on Twitter&#39;s Snowflake."},{"ref":"readme.html#description","title":"Exnowflake - Description","type":"extras","doc":"This app generates 64 bit integers, based on a timestamp, worker ID and a sequence: timestamp (milliseconds) - 42 bits worker - 10 bits (0 - 1023) sequence - 12 bits (0 - 4095) The worker ID can be an arbitrary integer between 0-1023, optionally a Redis connection should be configured to register/unregister nodes in order to get the worker number. Example =&gt; {:ok, id} = Exnowflake.generate() {:ok, 9522559057920} =&gt; Exnowflake.timestamp(id) 1565636645355"},{"ref":"readme.html#configuration","title":"Exnowflake - Configuration","type":"extras","doc":"Example: config :exnowflake, worker_id: {:system, &quot;WORKER_ID&quot;}, # Must be an integer between 0-1023 epoch: 1234567890 # custom epoch in milliseconds * Warning: if a custom epoch timestamp is given, it should not be reaplaced later or IDs overlap can occur. If no :worker_id configuration option is given, Exnowflake will attempt to connect to Redis with the given defaults which you can override: config :exnowflake, host: &quot;127.0.0.1&quot;, port: 6379, database: 0 You can also add the following options to redis connection: config :exnowflake, # ...other config options password: {:system, &quot;REDIS_PWD&quot;}, ssl: true, # defaults to false sync_connect: false #defaults to true For more info check Redix Documentation."},{"ref":"readme.html#usage","title":"Exnowflake - Usage","type":"extras","doc":"Generating an ID is very simple: =&gt; {:ok, id} = Exnowflake.generate() {:ok, 234527838437376} We can also retrieve the timestamp inside the ID: =&gt; Exnowflake.timestamp(id) 1574524265794 Or the internal timestamp, which returns how many milliseconds since epoch passed when ID was generated: =&gt; Exnowflake.internal_timestamp(id) 55915794 To get the current node worker ID, you can call: =&gt; Exnowflake.worker_id() 0"},{"ref":"readme.html#benchmarks","title":"Exnowflake - Benchmarks","type":"extras","doc":"Benchmarks can be run with: mix bench. These benchmarks were run with a Redis worker registry (no static worker ID given), on an iMac 4 GHz Intel Core i7 w/ 32GB RAM. Name ips average deviation median 99th % generate 283.71 K 3.52 μs ±414.17% 3 μs 5 μs worker_id 622.99 K 1.61 μs ±429.14% 2 μs 2 μs"}]